workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
      when: never 
    - when: always

vagrantbox:
  tags: [infrastructure]
  stage: .pre
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes:
        - Vagrantfile
  before_script:
    - VBoxManage list vms | awk '{ print $1 }' | xargs -I{} VBoxManage controlvm {} poweroff || true
    - VBoxManage list vms | awk '{ print $1 }' | xargs -I{} VBoxManage unregistervm --delete {} || true
    - vagrant global-status --no-tty --prune
  script:
    - VAGRANT_USE_HOST_REGISTRIES=yes VAGRANT_USE_LAKETOWER_MIRROR=yes vagrant up --no-tty
    - vagrant package --output /opt/prebuild_boxes/prebuild-infrastructure-box.box
    - vagrant box add --force --name infrastructure /opt/prebuild_boxes/prebuild-infrastructure-box.box
    - rm /opt/prebuild_boxes/prebuild-infrastructure-box.box
    - VBoxManage list vms | awk '{ print $1 }' | xargs -I{} VBoxManage controlvm {} poweroff || true
    - VBoxManage list vms | awk '{ print $1 }' | xargs -I{} VBoxManage unregistervm --delete {} || true
    - vagrant global-status --no-tty --prune

build:
  tags: [infrastructure]
  before_script:
    - VBoxManage list vms | awk '{ print $1 }' | xargs -I{} VBoxManage controlvm {} poweroff || true
    - VBoxManage list vms | awk '{ print $1 }' | xargs -I{} VBoxManage unregistervm --delete {} || true
    - vagrant global-status --no-tty --prune
  variables:
    TOOLING_IMAGE_TAG: latest
  rules:
    - if: $CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH
      variables:
        TOOLING_IMAGE_TAG: "latest-$CI_COMMIT_REF_SLUG"
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
      variables:
        TOOLING_IMAGE_TAG: latest
  script:
    - sudo docker compose -f docker-compose.yaml up -d --no-recreate
    - VAGRANT_BOX=infrastructure VAGRANT_USE_HOST_REGISTRIES=yes VAGRANT_USE_LAKETOWER_MIRROR=yes vagrant up --no-tty --no-provision
    - vagrant ssh --no-tty -c "TOOLING_IMAGE_TAG=$TOOLING_IMAGE_TAG VAGRANT_USE_HOST_REGISTRIES=yes /vagrant/create.sh"
    - VBoxManage list vms | awk '{ print $1 }' | xargs -I{} VBoxManage controlvm {} poweroff || true
    - VBoxManage list vms | awk '{ print $1 }' | xargs -I{} VBoxManage unregistervm --delete {} || true
    - vagrant global-status --no-tty --prune

build_tooling:
  tags: [raimo-dind]
  image: docker:28.0.0
  stage: build
  services:
    - name: docker:28.0.0-dind
      command: ["--registry-mirror", "https://mirror.gcr.io"]
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker buildx build -t tooling --cache-from=$CI_REGISTRY/$CI_PROJECT_PATH/tooling:latest --cache-from=$CI_REGISTRY/$CI_PROJECT_PATH/tooling:latest-$CI_COMMIT_REF_SLUG --cache-to=type=inline tooling/
    - |
      if [ "$CI_COMMIT_BRANCH" = "$CI_DEFAULT_BRANCH" ];
      then
        docker tag tooling $CI_REGISTRY/$CI_PROJECT_PATH/tooling:latest
        docker push $CI_REGISTRY/$CI_PROJECT_PATH/tooling:latest
      else
        docker tag tooling $CI_REGISTRY/$CI_PROJECT_PATH/tooling:latest-$CI_COMMIT_REF_SLUG
        docker push $CI_REGISTRY/$CI_PROJECT_PATH/tooling:latest-$CI_COMMIT_REF_SLUG
      fi

trigger_renovatebot:
  stage: .post
  rules:
    - if: $CI_COMMIT_REF_NAME =~ /^renovate\//
  trigger: 
    project: with-humans/devops-workshop/renovate-bot
    branch: main
